/* --COPYRIGHT--,FRAM-Utilities
 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * This source code is part of FRAM Utilities for MSP430 FRAM Microcontrollers.
 * Visit http://www.ti.com/tool/msp-fram-utilities for software information and
 * download.
 * --/COPYRIGHT--*/
#include <msp430.h>

#if defined(__MSP430FR2XX_4XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr2xx_4xxgeneric.h>
#elif defined(__MSP430FR57XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr57xxgeneric.h>
#elif defined(__MSP430FR5XX_6XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr5xx_6xxgeneric.h>
#endif

#ifdef __MSP430_HAS_ADC12_B__

#include <stdint.h>

#include "ctpl_adc12_b.h"
#include "ctpl_hwreg.h"
#include "../ctpl_low_level.h"
#include "../ctpl_copy.h"


void ctpl_ADC12_B_save(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Save register context to non-volatile storage. */
    storage[8] = HWREG16(baseAddress + OFS_ADC12CTL0);
    HWREG16(baseAddress + OFS_ADC12CTL0) &= ~ADC12ENC; // stop conversion
    HWREG16(baseAddress + OFS_ADC12CTL0) &= ~ADC12ON;  // disable ADC
    storage[7] = HWREG16(baseAddress + OFS_ADC12IER2);
    storage[6] = HWREG16(baseAddress + OFS_ADC12IER1);
    storage[5] = HWREG16(baseAddress + OFS_ADC12IER0);
    storage[4] = HWREG16(baseAddress + OFS_ADC12HI);
    storage[3] = HWREG16(baseAddress + OFS_ADC12LO);
    storage[2] = HWREG16(baseAddress + OFS_ADC12CTL3);
    storage[1] = HWREG16(baseAddress + OFS_ADC12CTL2);
    storage[0] = HWREG16(baseAddress + OFS_ADC12CTL1);

    ctpl_copy((uint16_t *)(baseAddress + OFS_ADC12MCTL0), &storage[9], 32);

    return;
}

void ctpl_ADC12_B_restore(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Restore register context from non-volatile storage. */
    ctpl_copy(&storage[9], (uint16_t *)(baseAddress + OFS_ADC12MCTL0), 32);

    HWREG16(baseAddress + OFS_ADC12CTL1)   = storage[0];
    HWREG16(baseAddress + OFS_ADC12CTL2)   = storage[1];
    HWREG16(baseAddress + OFS_ADC12CTL3)   = storage[2];
    HWREG16(baseAddress + OFS_ADC12LO)     = storage[3];
    HWREG16(baseAddress + OFS_ADC12HI)     = storage[4];
    HWREG16(baseAddress + OFS_ADC12IER0)   = storage[5];
    HWREG16(baseAddress + OFS_ADC12IER1)   = storage[6];
    HWREG16(baseAddress + OFS_ADC12IER2)   = storage[7];
    HWREG16(baseAddress + OFS_ADC12CTL0)   = storage[8];

    return;
}

#endif //__MSP430_HAS_ADC12_B__
