/* --COPYRIGHT--,FRAM-Utilities
 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * This source code is part of FRAM Utilities for MSP430 FRAM Microcontrollers.
 * Visit http://www.ti.com/tool/msp-fram-utilities for software information and
 * download.
 * --/COPYRIGHT--*/
#include <msp430.h>

#if defined(__MSP430FR2XX_4XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr2xx_4xxgeneric.h>
#elif defined(__MSP430FR57XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr57xxgeneric.h>
#elif defined(__MSP430FR5XX_6XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr5xx_6xxgeneric.h>
#endif

#ifdef __MSP430_HAS_CS__

#include <stdint.h>

#include "ctpl_cs.h"
#include "ctpl_hwreg.h"
#include "../ctpl_low_level.h"

void ctpl_CS_save(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Save register context to non-volatile storage. */
#if defined(__MSP430FR2XX_4XX_FAMILY__)
    storage[9] = __get_SR_register();
    storage[8] = HWREG16(baseAddress + OFS_CSCTL8);
    storage[7] = HWREG16(baseAddress + OFS_CSCTL7);
    storage[6] = HWREG16(baseAddress + OFS_CSCTL6);
    storage[5] = HWREG16(baseAddress + OFS_CSCTL5);
    storage[4] = HWREG16(baseAddress + OFS_CSCTL4);
    storage[3] = HWREG16(baseAddress + OFS_CSCTL3);
    storage[2] = HWREG16(baseAddress + OFS_CSCTL2);
    storage[1] = HWREG16(baseAddress + OFS_CSCTL1);
    storage[0] = HWREG16(baseAddress + OFS_CSCTL1);
#else
    storage[5] = HWREG16(baseAddress + OFS_CSCTL6);
    storage[4] = HWREG16(baseAddress + OFS_CSCTL5);
    storage[3] = HWREG16(baseAddress + OFS_CSCTL4);
    storage[2] = HWREG16(baseAddress + OFS_CSCTL3);
    storage[1] = HWREG16(baseAddress + OFS_CSCTL2);
    storage[0] = HWREG16(baseAddress + OFS_CSCTL1);
#endif

    return;
}

void ctpl_CS_restore(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Restore register context from non-volatile storage. */
#if defined(__MSP430FR2XX_4XX_FAMILY__)
    __bis_SR_register(SCG0);
    HWREG16(baseAddress + OFS_CSCTL0) = storage[0];
    HWREG16(baseAddress + OFS_CSCTL1) = storage[1];
    HWREG16(baseAddress + OFS_CSCTL2) = storage[2];
    HWREG16(baseAddress + OFS_CSCTL3) = storage[3];
    HWREG16(baseAddress + OFS_CSCTL4) = storage[4];
    HWREG16(baseAddress + OFS_CSCTL5) = storage[5];
    HWREG16(baseAddress + OFS_CSCTL6) = storage[6];
    if (!(storage[9] & SCG0)) {
        __delay_cycles(3);
        __bic_SR_register(SCG0);
        while(CSCTL7 & (FLLUNLOCK0 | FLLUNLOCK1));
    }
    HWREG16(baseAddress + OFS_CSCTL7) = storage[7];
    HWREG16(baseAddress + OFS_CSCTL8) = storage[8];
#else
    HWREG8(baseAddress + OFS_CSCTL0_H) = CSKEY_H;
    HWREG16(baseAddress + OFS_CSCTL1) = storage[0];
    HWREG16(baseAddress + OFS_CSCTL2) = storage[1];
    HWREG16(baseAddress + OFS_CSCTL3) = storage[2];
    HWREG16(baseAddress + OFS_CSCTL4) = storage[3];
    HWREG16(baseAddress + OFS_CSCTL5) = storage[4];
    HWREG16(baseAddress + OFS_CSCTL6) = storage[5];
    HWREG8(baseAddress + OFS_CSCTL0_H) = 0;
#endif

    return;
}

#endif //__MSP430_HAS_CS__
