/* --COPYRIGHT--,FRAM-Utilities
 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * This source code is part of FRAM Utilities for MSP430 FRAM Microcontrollers.
 * Visit http://www.ti.com/tool/msp-fram-utilities for software information and
 * download.
 * --/COPYRIGHT--*/
#include <msp430.h>

#if defined(__MSP430FR2XX_4XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr2xx_4xxgeneric.h>
#elif defined(__MSP430FR57XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr57xxgeneric.h>
#elif defined(__MSP430FR5XX_6XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr5xx_6xxgeneric.h>
#endif

#ifdef __MSP430_HAS_EUSCI_Bx__

#include <stdint.h>

#include "ctpl_eusci_b.h"
#include "ctpl_hwreg.h"
#include "../ctpl_low_level.h"

void ctpl_EUSCI_B_save(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Save register context to non-volatile storage. */
    storage[12] = HWREG16(baseAddress + OFS_UCBxCTLW0);

    /* stop USCI (set SW reset) */
    HWREG16(baseAddress + OFS_UCBxCTLW0) |= UCSWRST;

    storage[11] = HWREG16(baseAddress + OFS_UCBxIE);
    storage[10] = HWREG16(baseAddress + OFS_UCBxSTATW);
    storage[9]  = HWREG16(baseAddress + OFS_UCBxCTLW1);
    storage[8]  = HWREG16(baseAddress + OFS_UCBxBRW);
    storage[7]  = HWREG16(baseAddress + OFS_UCBxI2CSA);
    storage[6]  = HWREG16(baseAddress + OFS_UCBxADDMASK);
    storage[5]  = HWREG16(baseAddress + OFS_UCBxADDRX);
    storage[4]  = HWREG16(baseAddress + OFS_UCBxI2COA3);
    storage[3]  = HWREG16(baseAddress + OFS_UCBxI2COA2);
    storage[2]  = HWREG16(baseAddress + OFS_UCBxI2COA1);
    storage[1]  = HWREG16(baseAddress + OFS_UCBxI2COA0);
    storage[0]  = HWREG16(baseAddress + OFS_UCBxTBCNT);

    return;
}

void ctpl_EUSCI_B_restore(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Restore register context from non-volatile storage. */
    HWREG16(baseAddress + OFS_UCBxTBCNT)   = storage[0];
    HWREG16(baseAddress + OFS_UCBxI2COA0)  = storage[1];
    HWREG16(baseAddress + OFS_UCBxI2COA1)  = storage[2];
    HWREG16(baseAddress + OFS_UCBxI2COA2)  = storage[3];
    HWREG16(baseAddress + OFS_UCBxI2COA3)  = storage[4];
    HWREG16(baseAddress + OFS_UCBxADDRX)   = storage[5];
    HWREG16(baseAddress + OFS_UCBxADDMASK) = storage[6];
    HWREG16(baseAddress + OFS_UCBxI2CSA)   = storage[7];
    HWREG16(baseAddress + OFS_UCBxBRW)     = storage[8];
    HWREG16(baseAddress + OFS_UCBxCTLW1)   = storage[9];
    HWREG16(baseAddress + OFS_UCBxSTATW)   = storage[10];
    HWREG16(baseAddress + OFS_UCBxIE)      = storage[11];
    HWREG16(baseAddress + OFS_UCBxCTLW0)   = storage[12];

    return;
}

#endif //__MSP430_HAS_EUSCI_Bx__
