/* --COPYRIGHT--,FRAM-Utilities
 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * This source code is part of FRAM Utilities for MSP430 FRAM Microcontrollers.
 * Visit http://www.ti.com/tool/msp-fram-utilities for software information and
 * download.
 * --/COPYRIGHT--*/
#include <msp430.h>

#if defined(__MSP430FR2XX_4XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr2xx_4xxgeneric.h>
#elif defined(__MSP430FR57XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr57xxgeneric.h>
#elif defined(__MSP430FR5XX_6XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr5xx_6xxgeneric.h>
#endif

#ifdef __MSP430_HAS_LCD_C__

#include <stdint.h>

#include "ctpl_lcd_c.h"
#include "ctpl_hwreg.h"
#include "../ctpl_low_level.h"
#include "../ctpl_copy.h"

void ctpl_LCD_C_save(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Save register context to non-volatile storage. */
    storage[9] = HWREG16(baseAddress + OFS_LCDCCTL0);
    storage[8] = HWREG16(baseAddress + OFS_LCDCCPCTL);
    storage[7] = HWREG16(baseAddress + OFS_LCDCPCTL3);
    storage[6] = HWREG16(baseAddress + OFS_LCDCPCTL2);
    storage[5] = HWREG16(baseAddress + OFS_LCDCPCTL1);
    storage[4] = HWREG16(baseAddress + OFS_LCDCPCTL0);
    storage[3] = HWREG16(baseAddress + OFS_LCDCVCTL);
    storage[2] = HWREG16(baseAddress + OFS_LCDCMEMCTL);
    storage[1] = HWREG16(baseAddress + OFS_LCDCBLKCTL);
    storage[0] = HWREG16(baseAddress + OFS_LCDCCTL1);

    ctpl_copy((uint16_t *)(baseAddress + OFS_LCDM1), &storage[10], 32);
    
    return;
}

void ctpl_LCD_C_restore(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Restore register context from non-volatile storage. */
    ctpl_copy(&storage[10], (uint16_t *)(baseAddress + OFS_LCDM1), 32);
    
    HWREG16(baseAddress + OFS_LCDCCTL1)   = storage[0] & 0xFF00;
    HWREG16(baseAddress + OFS_LCDCBLKCTL) = storage[1];
    HWREG16(baseAddress + OFS_LCDCMEMCTL) = storage[2];
    HWREG16(baseAddress + OFS_LCDCVCTL)   = storage[3];
    HWREG16(baseAddress + OFS_LCDCPCTL0)  = storage[4];
    HWREG16(baseAddress + OFS_LCDCPCTL1)  = storage[5];
    HWREG16(baseAddress + OFS_LCDCPCTL2)  = storage[6];
    HWREG16(baseAddress + OFS_LCDCPCTL3)  = storage[7];
    HWREG16(baseAddress + OFS_LCDCCPCTL)  = storage[8];
    HWREG16(baseAddress + OFS_LCDCCTL0)   = storage[9];

    return;
}

#endif //__MSP430_HAS_LCD_C__
