/* --COPYRIGHT--,FRAM-Utilities
 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * This source code is part of FRAM Utilities for MSP430 FRAM Microcontrollers.
 * Visit http://www.ti.com/tool/msp-fram-utilities for software information and
 * download.
 * --/COPYRIGHT--*/
#include <msp430.h>

#if defined(__MSP430FR2XX_4XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr2xx_4xxgeneric.h>
#elif defined(__MSP430FR57XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr57xxgeneric.h>
#elif defined(__MSP430FR5XX_6XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr5xx_6xxgeneric.h>
#endif

#ifdef __MSP430_HAS_LCD_E__

#include <stdint.h>

#include "ctpl_lcd_e.h"
#include "ctpl_hwreg.h"
#include "../ctpl_low_level.h"
#include "../ctpl_copy.h"

void ctpl_LCD_E_save(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Save register context to non-volatile storage. */
    storage[10] = HWREG16(baseAddress + OFS_LCDCTL0);
    storage[9] = HWREG16(baseAddress + OFS_LCDCSSEL2);
    storage[8] = HWREG16(baseAddress + OFS_LCDCSSEL1);
    storage[7] = HWREG16(baseAddress + OFS_LCDCSSEL0);
    storage[6] = HWREG16(baseAddress + OFS_LCDPCTL2);
    storage[5] = HWREG16(baseAddress + OFS_LCDPCTL1);
    storage[4] = HWREG16(baseAddress + OFS_LCDPCTL0);
    storage[3] = HWREG16(baseAddress + OFS_LCDVCTL);
    storage[2] = HWREG16(baseAddress + OFS_LCDMEMCTL);
    storage[1] = HWREG16(baseAddress + OFS_LCDBLKCTL);
    storage[0] = HWREG16(baseAddress + OFS_LCDCTL1);

    ctpl_copy((uint16_t *)(baseAddress + OFS_LCDM0W), &storage[11], 32);
    
    return;
}

void ctpl_LCD_E_restore(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Restore register context from non-volatile storage. */
    ctpl_copy(&storage[11], (uint16_t *)(baseAddress + OFS_LCDM0W), 32);
    
    HWREG16(baseAddress + OFS_LCDCTL1)   = storage[0] & 0xFF00;
    HWREG16(baseAddress + OFS_LCDBLKCTL) = storage[1];
    HWREG16(baseAddress + OFS_LCDMEMCTL) = storage[2];
    HWREG16(baseAddress + OFS_LCDVCTL)   = storage[3];
    HWREG16(baseAddress + OFS_LCDPCTL0)  = storage[4];
    HWREG16(baseAddress + OFS_LCDPCTL1)  = storage[5];
    HWREG16(baseAddress + OFS_LCDPCTL2)  = storage[6];
    HWREG16(baseAddress + OFS_LCDCSSEL0)  = storage[7];
    HWREG16(baseAddress + OFS_LCDCSSEL1)  = storage[8];
    HWREG16(baseAddress + OFS_LCDCSSEL2)  = storage[9];
    HWREG16(baseAddress + OFS_LCDCTL0)   = storage[10];

    return;
}

#endif //__MSP430_HAS_LCD_E__
