/* --COPYRIGHT--,FRAM-Utilities
 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * This source code is part of FRAM Utilities for MSP430 FRAM Microcontrollers.
 * Visit http://www.ti.com/tool/msp-fram-utilities for software information and
 * download.
 * --/COPYRIGHT--*/
#include <msp430.h>

#if defined(__MSP430FR2XX_4XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr2xx_4xxgeneric.h>
#elif defined(__MSP430FR57XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr57xxgeneric.h>
#elif defined(__MSP430FR5XX_6XX_FAMILY__) && !defined(__AUTOGENERATED__)
#include <msp430fr5xx_6xxgeneric.h>
#endif

#ifdef __MSP430_HAS_SYS__

#include <stdint.h>

#include "ctpl_sys.h"
#include "ctpl_hwreg.h"
#include "../ctpl_low_level.h"

void ctpl_SYS_save(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Save register context to non-volatile storage. */
#if defined(__MSP430FR2XX_4XX_FAMILY__)
    storage[4] = HWREG16(baseAddress + OFS_SYSCFG2);
    storage[3] = HWREG16(baseAddress + OFS_SYSCFG1);
    storage[2] = HWREG16(baseAddress + OFS_SYSCFG0);
#endif
    storage[1] = HWREG16(baseAddress + OFS_SYSJMBC);
    storage[0] = HWREG16(baseAddress + OFS_SYSCTL);

    return;
}

void ctpl_SYS_restore(uint16_t baseAddress, uint16_t *storage, uint16_t mode)
{
    /* Restore register context from non-volatile storage. */
    HWREG16(baseAddress + OFS_SYSCTL) = storage[0];
    HWREG16(baseAddress + OFS_SYSJMBC) = storage[1];
    
#if defined(__MSP430FR2XX_4XX_FAMILY__)
#if defined(FRWPPW)
    HWREG16(baseAddress + OFS_SYSCFG0) = (storage[2] & 0x00ff) | FRWPPW;
#else
    HWREG16(baseAddress + OFS_SYSCFG0) = storage[2];
#endif
    HWREG16(baseAddress + OFS_SYSCFG1) = storage[3];
    HWREG16(baseAddress + OFS_SYSCFG2) = storage[4];
#endif

    /* Clear pending reset IFG's all modes. */
    HWREG16(baseAddress + OFS_SYSRSTIV) = 0;

    return;
}

#endif //__MSP430_HAS_SYS__
